#ifndef ROOM_H_
#define ROOM_H_
#include <map>
#include <list>
#include "MapSite.h"
#include "Wall.h"
#include "Thing.h"
class Room : public MapSite {
	friend class RoomTestSuite; 
	public:
		Room(int const number=0);
		virtual ~Room();
		void enter();
		int getNumber() const;
		MapSite *getSide(MapSite::Direction direction) const;
		MapSite *setSide(MapSite::Direction direction,MapSite *mapSite);
	protected:
		void setNumber(int const number);
	private:
		int number_;
		map<MapSite::Direction,MapSite *> sides_;
		MapSite *mapSite_[MapSite::directions];
		list<Thing *> things;
	};
#endif /*ROOM_H_*/
