#ifndef MAZEGAMETESTCASE_H_
#define MAZEGAMETESTCASE_H_
#include <cxxtest/TestSuite.h>
#include "../inc/MazeGame.h"
class MazeGameTestCase:public CxxTest::TestSuite {
	public:
		MazeGameTestCase() {}
		virtual ~MazeGameTestCase() {}
        void setUp() { game=new MazeGame(); }
        void tearDown() { delete game; }
		void xxtestCreateMaze() throw() {
			Maze *m=game->createMaze();
			delete m;
		}
		void testCreateMaze() throw() {
			Maze *const m=game->createMaze();
			Room const*const r1=m->getRoom(1);
			TS_ASSERT(r1!=NULL);
			Room const*const r2=m->getRoom(2);
			TS_ASSERT(r2!=NULL);
			Door const*const d1=(Door *)r1->getSide(MapSite::east);
			Door const*const d2=(Door *)r2->getSide(MapSite::west);
			TS_ASSERT(d1==d2);
			TS_ASSERT(r2==d1->otherSideFrom(*r1));
			TS_ASSERT(r1==d2->otherSideFrom(*r2));
			delete m;
		}
	protected:
		MazeGame *game;
};
#endif /*MAZEGAMETESTCASE_H_*/
