#ifndef MAZETESTSUITE_H_
#define MAZETESTSUITE_H_
#include <cxxtest/TestSuite.h>
#include "../inc/Maze.h"
class MazeTestSuite:public CxxTest::TestSuite {
	public:
		MazeTestSuite();
		virtual ~MazeTestSuite();
        void setUp() { m=new Maze(); }
        void tearDown() {delete m; }
        void testAddRoom() throw() {
			m->addRoom(new Room(1));
        }
        void testAddRooms() throw() {
        	for(int i=0;i<10;i++)
	        	m->addRoom(new Room(i));
        }
        void testDtor() throw() {
        	new char[100],new char[101],new char[102],new char[103]; // force an error 
        	Room *r1=new Room(1);
        	m->addRoom(r1);
        	Wall *w=new Wall();
			r1->setSide(MapSite::north,w);
			r1->setSide(MapSite::south,new Wall());
			r1->setSide(MapSite::east,new Wall());
			r1->setSide(MapSite::west,new Wall());
        }
        void testDtor2() throw() {
        	Room *r1=new Room(1);
        	m->addRoom(r1);
			r1->setSide(MapSite::north,new Wall());
        	Room *r2=new Room(2);
        	m->addRoom(r2);
        	Door *d=new Door(r1,NULL);
			r2->setSide(MapSite::north,d);
        }
		void testUseSameSide() throw() {
			Wall *w=new Wall();
			Room *r1=new Room(1);
			m->addRoom(r1);
			r1->setSide(MapSite::north,w);
			r1->setSide(MapSite::south,w);
			r1->setSide(MapSite::east,w);
			r1->setSide(MapSite::west,w);
		}
		protected:
			Maze *m;
};
#endif /*MAZETESTSUITE_H_*/
