#ifndef ROOMTESTSUITE_H_
#define ROOMTESTSUITE_H_
#include <cxxtest/TestSuite.h>
#include "../inc/Room.h"
class RoomTestSuite:public CxxTest::TestSuite {
	public:
		//RoomTestSuite();
        void setUp() { r1=new Room(1); }
        void tearDown() { delete r1; r1=NULL; }
		void testEnter() throw() {
			r1->enter();
		}
		void testGetNumber() throw() {
			TS_ASSERT(1==r1->getNumber());
		}
		void testSetNumber() throw() {
			int const expected=42;
			r1->setNumber(expected);
			TS_ASSERT(expected==r1->getNumber());
		}
		void testGetSide() throw() {
			MapSite *expected=NULL;
			for(MapSite::Direction d=MapSite::north;d<MapSite::directions;d=(MapSite::Direction)(d+1))
				TS_ASSERT(expected==r1->getSide(d));
		}
		void testSetSide() throw() {
			for(MapSite::Direction d=MapSite::north;d<MapSite::directions;d=(MapSite::Direction)(d+1)) {
				Wall *expected=new Wall();
				MapSite *previous=r1->setSide(d,expected);
				TS_ASSERT(previous==NULL);
				TS_ASSERT(expected==r1->getSide(d));
				delete expected;
			}
		}
		void testSetSameSideTwice() throw() {
			for(MapSite::Direction d=MapSite::north;d<MapSite::directions;d=(MapSite::Direction)(d+1)) {
				Wall *original=new Wall();
				Wall *expected=new Wall();
				r1->setSide(d,original);
				MapSite *previous=r1->setSide(d,expected);
				TS_ASSERT(original==previous); // failing here
				delete original;
				MapSite *actual=r1->getSide(d);
				TS_ASSERT(expected==actual);
				delete expected;
			}
		}
	protected:
		Room *r1;
};
#endif /*ROOMTESTSUITE_H_*/
